#define maxport 8
#define maxport2 2

#include <dos.h>
#include <stdio.h>
#include <conio.h>
#include <ctype.h>
#include "diumon.h"
#include "irq0-15.h"


void interrupt ISR(...)
{ int n=0;
  int which,stat;         //set out2s off
  while(which = inportb(com[0].base + 0x40/*0x0400 com-4s and com-8s*/))

	 while (which && (n<8)) {
		outportb(0x61,0x3);
		if (which & 0x01){
		  if (inportb(com[n].base + 2) & 0x04){ // if data is waiting
			 com[n].data[++com[n].head] = inportb(com[n].base); // read & store
			 com[n].head%=256;
		  }
		}
		which >>=1;
		n++;
		outportb(0x61,0x0);
	 } // end while
//  }//end while status shows IRQ
  sendEOI();
}

void setTitleWindow(){window(1,1,80,1);textattr((BLUE<<4)|(WHITE));}
void setSideWindow(){ window(1,1,4,25);textattr((BLUE<<4)|(WHITE));}
void setFullWindow(){ window(1,1,80,25);textattr((BLACK<<4)|(LIGHTGRAY));}

void setComWindow(unsigned char n)
{ window(com[n].x1,com[n].y1,com[n].x2,com[n].y2);
  textbackground(com[n].bc);
  textcolor(com[n].fc);
  gotoxy(com[n].x,com[n].y);
}

void drawsidebar()
{ int n=0;
  setSideWindow();
  clrscr();
  for (n=0;n<maxport2;n++){
	 gotoxy(1,n*(24/maxport2)+3);
	 printf("COM%c",n+'A');
	 gotoxy(1,n*(24/maxport2)+4);
	 printf("DATA");
  }
  gotoxy(1,OUT * (24/maxport2) + 2);
  cputs("OUT");

}


void drawscreen()
{
  setTitleWindow();
  clrscr();
  gotoxy(5,1);
  cputs("PCI-COM-8S / DIU Monitor.  Version 1.00   F10 for help, ALT-X to eXit.");
  for (int i=0;i<maxport2;i++){
	 setComWindow(i);clrscr();
  }
  setSideWindow();
  drawsidebar();
}

void drawhelp()
{
  setFullWindow();
  textattr((BLUE<<4)|YELLOW);
  clrscr();
  cputs("PCI-COM-8S / DIU Monitor.\n\r");
  cputs("\n\n\n\r");
  cputs("Use F10 for help\n\r");
  cputs("Use ALT-X to exit\n\r");
  cputs("Use F1-F8 for Output COM Port selection.  F1=COMA, F2=COMB etc.\n\r");
  cputs("\n\r");
  cputs("COM ports addresses are read from address.txt\n\r");
  cputs("COM port IRQ is read from address.txt\n\r");
  getch();
  drawscreen();
  
}

unsigned handledata()
{ int n=0;unsigned char dat; static unsigned char chars;
  for (n=0;n<maxport2;n++){
	  while (com[n].head != com[n].tail){
		 setComWindow(n);
//		 putch(dat=com[n].data[++com[n].tail]);
		 printf("%02hx ",dat=com[n].data[++com[n].tail]);
		 if (dat==0x0D) {putch(dat);putch(0x0a);}
//		 if (dat==0x08) {putch(' ');putch(dat);}
		 ++chars;
       if (chars >= 25) printf("\n"); 

		 com[n].x=wherex();
		 com[n].y=wherey();
     }
  }
  return 0;//debug -- add error conditionals
}

unsigned handlekeys()
{ unsigned char key=0;
  if (!kbhit()) return 0;               //if no character continue program
  setComWindow(OUT);
  key=getch();
  if (!key){
    key=getch();
    switch(key){
       case 45:return 1; //ALT-X
       //case 67:geninterrupt(10+0x68);break;//IRQ+((IRQ<8)?8:0x68));break;
       case 59: // F1-F8
       case 60:
       case 61:
       case 62:
		 case 63:
       case 64:
       case 65:
		 case 66: OUT=(key-59) % maxport2;
		drawsidebar();
		break;
       case 68: drawhelp();
    }//end switch
  }else{
     int timeout = 65535;
     do{
	timeout--;
     }while (!(((inportb(com[OUT].base+5) & 0x20)) || (timeout==0)));

     if (timeout == 0) {
	setComWindow(OUT);
	cputs("Hardware transmission failure #1!");
	return 1;
     }
     outportb(com[OUT].base,key);
	  printf("%02hx ",key);
//     putch(key);
//     if (key==0x08) {putch(' ');putch(key);}
     com[OUT].x=wherex();
     com[OUT].y=wherey();
//     delay(1);
//     geninterrupt(5+8);
  }//end else
  return 0;
}

void initcomms(void)
{
   unsigned divisor;
	divisor = 115200L / 28800L;
	for (int n=0;n<maxport;n++){
		outportb(com[n].base+3,0x80);
		outportb(com[n].base,divisor & 0x00ff);
		outportb(com[n].base+1,divisor >> 8);
		outportb(com[n].base+3,0x03);	// 7e1+non-dlab  (1A|03)
		outportb(com[n].base+4,0x09);             //out2+dtr
      outportb(com[n].base+1,0x01);	// enable irqs
      inportb(com[n].base);// clear data and IRQ
      inportb(com[n].base);// clear data and IRQ
   }
}

void initvars()
{ FILE *cfg;
  char msg[10];
  int i=0;
  IRQ=0;
  OUT=0;
  if ((cfg = fopen("address.txt", "rt")) == NULL){
    fprintf(stderr, "Cannot open input file.\n");
  }
  for(i=0;i<maxport;i++){
//    com[i].base=0x200+(i*0x08);
    fgets(msg,6,cfg);
    sscanf(msg,"%x",&com[i].base);
    com[i].head=0;
    com[i].tail=0;
    com[i].x1=5;
    com[i].x2=80;
	 com[i].y1=i*(24/maxport2)+2;
	 com[i].y2=com[i].y1+((24/maxport2)-1);
    com[i].x=1;
    com[i].y=1;
    com[i].bc=(i&1)?CYAN:BLUE;
    com[i].fc=YELLOW;
    for(int j=0;j<256;j++)
      com[i].data[j]=0;
  }
  fgets(msg,3,cfg);
  sscanf(msg,"%x",&IRQ);
  fclose(cfg);
}

void main(void)
{ unsigned done=0;
  initvars();
  drawscreen();
  initirq(IRQ);
  initcomms();
  delay(10);
  sendEOI();
  do{
     done+=handledata();
     done+=handlekeys();
  }while(!done);
  restoreirq(IRQ);
  sendEOI();
  handledata();
  setFullWindow();
  clrscr();
}